{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_abra"
            ],
            "label": "cmo-abra",
            "arguments": [
                {
                    "valueFrom": "2.17",
                    "prefix": "--version",
                    "position": 0
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": "$(inputs.runparams.abra_ram_min)",
                    "coresMin": 16,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Set mapq for alignments that map equally well to reference and an ABRA generated contig. default of -1 disables (default - -1)",
                    "inputBinding": {
                        "prefix": "--amq"
                    },
                    "id": "#cmo-abra.cwl/amq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "bwa ref",
                    "inputBinding": {
                        "prefix": "--bwa-ref"
                    },
                    "id": "#cmo-abra.cwl/bwa_ref"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Contig anchor [M_bases_at_contig_edge, max_mismatches_near_edge] (default - 10,2)",
                    "inputBinding": {
                        "prefix": "--ca"
                    },
                    "id": "#cmo-abra.cwl/ca"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Compression level of output bam file (s) (default - 5)",
                    "inputBinding": {
                        "prefix": "--cl"
                    },
                    "id": "#cmo-abra.cwl/cl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Use positional consensus sequence when aligning high quality soft clipping",
                    "inputBinding": {
                        "prefix": "--cons"
                    },
                    "id": "#cmo-abra.cwl/cons"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Optional file to which assembled contigs are written",
                    "inputBinding": {
                        "prefix": "--contigs"
                    },
                    "id": "#cmo-abra.cwl/contigs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max read move distance (default - 1000)",
                    "inputBinding": {
                        "prefix": "--dist"
                    },
                    "id": "#cmo-abra.cwl/dist"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "If specified, use GKL Intel Deflater (experimental)",
                    "inputBinding": {
                        "prefix": "--gkl"
                    },
                    "id": "#cmo-abra.cwl/gkl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "GTF file defining exons and transcripts",
                    "inputBinding": {
                        "prefix": "--gtf"
                    },
                    "id": "#cmo-abra.cwl/gtf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "doc": "Required list of input sam or bam file (s) separated by comma",
                    "inputBinding": {
                        "itemSeparator": ",",
                        "prefix": "--in"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#cmo-abra.cwl/in"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "VCF containing known (or suspected) variant sites. Very large files should be avoided.",
                    "inputBinding": {
                        "prefix": "--in-vcf"
                    },
                    "id": "#cmo-abra.cwl/in_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Enable BAM index generation when outputting sorted alignments (may require additonal memory)",
                    "inputBinding": {
                        "prefix": "--index"
                    },
                    "id": "#cmo-abra.cwl/index"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Splice junctions definition file",
                    "inputBinding": {
                        "prefix": "--junctions"
                    },
                    "id": "#cmo-abra.cwl/junctions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not delete the temporary directory",
                    "inputBinding": {
                        "prefix": "--keep-tmp"
                    },
                    "id": "#cmo-abra.cwl/keep_tmp"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Optional assembly kmer size(delimit with commas if multiple sizes specified)",
                    "inputBinding": {
                        "prefix": "--kmer"
                    },
                    "id": "#cmo-abra.cwl/kmer"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Logging level (trace,debug,info,warn, error) (default - info)",
                    "inputBinding": {
                        "prefix": "--log"
                    },
                    "id": "#cmo-abra.cwl/log"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max assembled contigs (default - 64)",
                    "inputBinding": {
                        "prefix": "--mac"
                    },
                    "id": "#cmo-abra.cwl/mac"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Regions with average depth exceeding this value will be downsampled (default - 1000)",
                    "inputBinding": {
                        "prefix": "--mad"
                    },
                    "id": "#cmo-abra.cwl/mad"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum mapping quality for a read to be used in assembly and be eligible for realignment (default - 20)",
                    "inputBinding": {
                        "prefix": "--mapq"
                    },
                    "id": "#cmo-abra.cwl/mapq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Maximum pre-pruned nodes in regional assembly (default - 150000)",
                    "inputBinding": {
                        "prefix": "--maxn"
                    },
                    "id": "#cmo-abra.cwl/maxn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum base quality for inclusion in assembly. This value is compared against the sum of base qualities per kmer position (default - 20)",
                    "inputBinding": {
                        "prefix": "--mbq"
                    },
                    "id": "#cmo-abra.cwl/mbq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Assembly minimum contig length (default - -1)",
                    "inputBinding": {
                        "prefix": "--mcl"
                    },
                    "id": "#cmo-abra.cwl/mcl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max number of cached reads per sample per thread (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--mcr"
                    },
                    "id": "#cmo-abra.cwl/mcr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Min edge pruning ratio. Default value is appropriate for relatively sensitive somatic cases. May be increased for improved speed in germline only cases. (default - 0.01)",
                    "inputBinding": {
                        "prefix": "--mer"
                    },
                    "id": "#cmo-abra.cwl/mer"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max allowed mismatch rate when mapping reads back to contigs (default - 0.05)",
                    "inputBinding": {
                        "prefix": "--mmr"
                    },
                    "id": "#cmo-abra.cwl/mmr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Assembly minimum node frequency (default - 1)",
                    "inputBinding": {
                        "prefix": "--mnf"
                    },
                    "id": "#cmo-abra.cwl/mnf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Reads with noise score exceeding this value are not remapped. numMismatches+(numIndels*2) < readLength*mnr (default - 0.1)",
                    "inputBinding": {
                        "prefix": "--mrn"
                    },
                    "id": "#cmo-abra.cwl/mrn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Regions containing more reads than this value are not processed. Use -1 to disable. (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--mrr"
                    },
                    "id": "#cmo-abra.cwl/mrr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max reads to keep in memory per sample during the sort phase. When this value is exceeded, sort spills to disk (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--msr"
                    },
                    "id": "#cmo-abra.cwl/msr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not attempt to sort final output",
                    "inputBinding": {
                        "prefix": "--nosort"
                    },
                    "id": "#cmo-abra.cwl/nosort"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "doc": "Required list of output sam or bam file (s) separated by comma",
                    "inputBinding": {
                        "itemSeparator": ",",
                        "prefix": "--out"
                    },
                    "id": "#cmo-abra.cwl/out"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum read candidate fraction for triggering assembly (default - 0.01)",
                    "inputBinding": {
                        "prefix": "--rcf"
                    },
                    "id": "#cmo-abra.cwl/rcf"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--reference_sequence"
                    },
                    "id": "#cmo-abra.cwl/ref"
                },
                {
                    "type": {
                        "type": "record",
                        "fields": [
                            {
                                "type": "int",
                                "name": "#cmo-abra.cwl/runparams/abra_ram_min"
                            }
                        ]
                    },
                    "id": "#cmo-abra.cwl/runparams"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Skip assembly",
                    "inputBinding": {
                        "prefix": "--sa"
                    },
                    "id": "#cmo-abra.cwl/sa"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Soft clip contig args [max_contigs, min_base_qual,frac_high_qual_bases, min_soft_clip_len] (default - 16,13,80,15)",
                    "inputBinding": {
                        "prefix": "--sc"
                    },
                    "id": "#cmo-abra.cwl/sc"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Scoring used for contig alignments (match, mismatch_penalty, gap_open_penalty, gap_extend_penalty) (default - 8,32,48,1)",
                    "inputBinding": {
                        "prefix": "--sga"
                    },
                    "id": "#cmo-abra.cwl/sga"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Input is single end",
                    "inputBinding": {
                        "prefix": "--single"
                    },
                    "id": "#cmo-abra.cwl/single"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "If no target specified, skip realignment of chromosomes matching specified regex. Skipped reads are output without modification. Specify none to disable. (default - GL.*|hs37d5|chr.*random|chrUn. *|chrEBV|CMV|HBV|HCV.*|HIV. *|KSHV|HTLV.*|MCV|SV40|HPV.*)",
                    "inputBinding": {
                        "prefix": "--skip"
                    },
                    "id": "#cmo-abra.cwl/skip"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not use observed indels in original alignments to generate contigs",
                    "inputBinding": {
                        "prefix": "--sobs"
                    },
                    "id": "#cmo-abra.cwl/sobs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Skip usage of soft clipped sequences as putative contigs",
                    "inputBinding": {
                        "prefix": "--ssc"
                    },
                    "id": "#cmo-abra.cwl/ssc"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not use unmapped reads anchored by mate to trigger assembly. These reads are still eligible to contribute to assembly",
                    "inputBinding": {
                        "prefix": "--sua"
                    },
                    "id": "#cmo-abra.cwl/sua"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "BED-like file containing target regions with per region kmer sizes in 4th column",
                    "inputBinding": {
                        "prefix": "--target-kmers"
                    },
                    "id": "#cmo-abra.cwl/target_kmers"
                },
                {
                    "type": [
                        "null",
                        "File",
                        "string"
                    ],
                    "doc": "BED file containing target regions",
                    "inputBinding": {
                        "prefix": "--targets"
                    },
                    "id": "#cmo-abra.cwl/targets"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of threads (default - 4)",
                    "inputBinding": {
                        "prefix": "--threads"
                    },
                    "default": "8",
                    "id": "#cmo-abra.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Set the temp directory (overrides java. io.tmpdir)",
                    "inputBinding": {
                        "prefix": "--tmpdir"
                    },
                    "id": "#cmo-abra.cwl/tmpdir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Unset duplicate flag",
                    "inputBinding": {
                        "prefix": "--undup"
                    },
                    "id": "#cmo-abra.cwl/undup"
                },
                {
                    "doc": "Working directory for intermediate output. Must not already exist",
                    "inputBinding": {
                        "prefix": "--working"
                    },
                    "type": "string",
                    "id": "#cmo-abra.cwl/working"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Processing window size and overlap (size,overlap) (default - 400,200)",
                    "inputBinding": {
                        "prefix": "--ws"
                    },
                    "id": "#cmo-abra.cwl/ws"
                }
            ],
            "id": "#cmo-abra.cwl",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cmo-abra",
                    "http://usefulinc.com/ns/doap#revision": 2.17
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Nikhil Kumar",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:kumarn1@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.abra.bam"
                    },
                    "id": "#cmo-abra.cwl/outbams"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_gatk"
            ],
            "label": "cmo-gatk-BaseRecalibrator",
            "arguments": [
                {
                    "valueFrom": "BaseRecalibrator",
                    "prefix": "-T",
                    "position": 0
                },
                {
                    "valueFrom": "3.3-0",
                    "prefix": "--version",
                    "position": 0
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 24000,
                    "coresMin": 2,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/BQSR"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "the binary tag covariate name if using it",
                    "inputBinding": {
                        "prefix": "--binary_tag_name"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/binary_tag_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BQSR BAQ gap open penalty (Phred Scaled). Default value is 40. 30 is perhaps better for whole genome call sets",
                    "inputBinding": {
                        "prefix": "--bqsrBAQGapOpenPenalty"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/bqsrBAQGapOpenPenalty"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "--covariate"
                        }
                    },
                    "doc": "One or more covariates to be used in the recalibration. Can be specified multiple times",
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/covariate"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base deletions covariate",
                    "inputBinding": {
                        "prefix": "--deletions_default_quality"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/deletions_default_quality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE|ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/globalQScorePrior"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Size of the k-mer context to be used for base insertions and deletions",
                    "inputBinding": {
                        "prefix": "--indels_context_size"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/indels_context_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File",
                            "inputBinding": {
                                "prefix": "--input_file"
                            }
                        }
                    ],
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base insertions covariate",
                    "inputBinding": {
                        "prefix": "--insertions_default_quality"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/insertions_default_quality"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/interval_set_rule"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals over which to operate",
                    "inputBinding": {
                        "prefix": "--intervals"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "-Xmx48g -Xms256m -XX:-UseGCOverheadLimit",
                    "doc": "args to pass to java",
                    "inputBinding": {
                        "prefix": "--java_args"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/java_args"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "java.io.temp_dir, if you want to set it",
                    "inputBinding": {
                        "prefix": "--java-temp"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/java_temp"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/keep_program_records"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--knownSites"
                        }
                    },
                    "doc": "A database of known polymorphic sites to skip over in the recalibration algorithm",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/knownSites"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "List the available covariates and exit",
                    "inputBinding": {
                        "prefix": "--list"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/logging_level"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Reduce memory usage in multi-threaded code at the expense of threading efficiency",
                    "inputBinding": {
                        "prefix": "--lowMemoryMode"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/lowMemoryMode"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "minimum quality for the bases in the tail of the reads to be considered",
                    "inputBinding": {
                        "prefix": "--low_quality_tail"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/low_quality_tail"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The maximum cycle value permitted for the Cycle covariate",
                    "inputBinding": {
                        "prefix": "--maximum_cycle_value"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/maximum_cycle_value"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Size of the k-mer context to be used for base mismatches",
                    "inputBinding": {
                        "prefix": "--mismatches_context_size"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/mismatches_context_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base mismatches covariate",
                    "inputBinding": {
                        "prefix": "--mismatches_default_quality"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/mismatches_default_quality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Do not use the standard set of covariates, but rather just the ones listed using the -cov argumentthout_dbsnp_potentially_ruining_quality,--run_without_dbsnp_potentially_ruining_quality If specified, allows the recalibrator to be used without a dbsnp rod. Very unsafe and for expert users only.",
                    "inputBinding": {
                        "prefix": "--no_standard_covs"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/no_standard_covs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "2",
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/num_threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "The output recalibration table file to create",
                    "inputBinding": {
                        "prefix": "--out"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS|STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "number of distinct quality scores in the quantized output",
                    "inputBinding": {
                        "prefix": "--quantizing_levels"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/quantizing_levels"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/refactor_NDN_cigar_string"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/sites_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Defines the behavior of the recalibrator when it encounters no calls in the color space. Options = THROW_EXCEPTION, LEAVE_READ_UNRECALIBRATED, or PURGE_READ (THROW_EXCEPTION| LEAVE_READ_UNRECALIBRATED| PURGE_READ)",
                    "inputBinding": {
                        "prefix": "--solid_nocall_strategy"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/solid_nocall_strategy"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How should we recalibrate solid bases in which the reference was inserted? Options = DO_NOTHING, SET_Q_ZERO, SET_Q_ZERO_BASE_N, or REMOVE_REF_BIAS (DO_NOTHING| SET_Q_ZERO|SET_Q_ZERO_BASE_N| REMOVE_REF_BIAS)",
                    "inputBinding": {
                        "prefix": "--solid_recal_mode"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/solid_recal_mode"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Sort the rows in the tables of reports",
                    "inputBinding": {
                        "prefix": "--sort_by_all_columns"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/sort_by_all_columns"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stderr to file",
                    "inputBinding": {
                        "prefix": "--stderr"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/stderr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stdout to file",
                    "inputBinding": {
                        "prefix": "--stdout"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/stdout"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/tag"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#cmo-gatk.BaseRecalibrator.cwl/recal_matrix"
                }
            ],
            "id": "#cmo-gatk.BaseRecalibrator.cwl",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cmo-gatk.BaseRecalibrator",
                    "http://usefulinc.com/ns/doap#revision": "3.3-0"
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_gatk"
            ],
            "label": "cmo-gatk-FindCoveredIntervals",
            "arguments": [
                {
                    "valueFrom": "FindCoveredIntervals",
                    "prefix": "-T",
                    "position": 0
                },
                {
                    "valueFrom": "3.3-0",
                    "prefix": "--version",
                    "position": 0
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 24000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/BQSR"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Threshold for the probability of a profile state being active.",
                    "inputBinding": {
                        "prefix": "--activeProbabilityThreshold"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activeProbabilityThreshold"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The active region extension; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--activeRegionExtension"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activeRegionExtension"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Use this interval list file as the active regions to process",
                    "inputBinding": {
                        "prefix": "--activeRegionIn"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activeRegionIn"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The active region maximum size; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--activeRegionMaxSize"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activeRegionMaxSize"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Output the active region to this IGV formatted file",
                    "inputBinding": {
                        "prefix": "--activeRegionOut"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activeRegionOut"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Output the raw activity profile results in IGV format",
                    "inputBinding": {
                        "prefix": "--activityProfileOut"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/activityProfileOut"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The sigma of the band pass filter Gaussian kernel; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--bandPassSigma"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/bandPassSigma"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable coverage to be considered covered",
                    "inputBinding": {
                        "prefix": "--coverage_threshold"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/coverage_threshold"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE| ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, all bases will be tagged as active",
                    "inputBinding": {
                        "prefix": "--forceActive"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/forceActive"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/globalQScorePrior"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--input_file"
                        }
                    },
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/interval_set_rule"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string",
                            "inputBinding": {
                                "prefix": "--intervals"
                            }
                        }
                    ],
                    "doc": "One or more genomic intervals over which to operate",
                    "inputBinding": {
                        "prefix": null
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "-Xmx48g -Xms256m -XX:-UseGCOverheadLimit",
                    "doc": "args to pass to java",
                    "inputBinding": {
                        "prefix": "--java_args"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/java_args"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "java.io.temp_dir, if you want to set it",
                    "inputBinding": {
                        "prefix": "--java-temp"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/java_temp"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/keep_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/logging_level"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable base quality score to be counted for coverage",
                    "inputBinding": {
                        "prefix": "--minBaseQuality"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/minBaseQuality"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable mapping quality score to be counted for coverage",
                    "inputBinding": {
                        "prefix": "--minMappingQuality"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/minMappingQuality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/num_threads"
                },
                {
                    "type": "string",
                    "doc": "An output file created by the walker. Will overwrite contents if file exists",
                    "inputBinding": {
                        "prefix": "--out"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS| STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/refactor_NDN_cigar_string"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/sites_only"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stderr to file",
                    "inputBinding": {
                        "prefix": "--stderr"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/stderr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stdout to file",
                    "inputBinding": {
                        "prefix": "--stdout"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/stdout"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/tag"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "output intervals that fail the coverage threshold instead",
                    "inputBinding": {
                        "prefix": "--uncovered"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/uncovered"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#cmo-gatk.FindCoveredIntervals.cwl/fci_list"
                }
            ],
            "id": "#cmo-gatk.FindCoveredIntervals.cwl",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cmo-gatk.FindCoveredIntervals",
                    "http://usefulinc.com/ns/doap#revision": "3.3-0"
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_gatk"
            ],
            "label": "cmo-gatk-PrintReads",
            "arguments": [
                {
                    "valueFrom": "PrintReads",
                    "prefix": "-T",
                    "position": 0
                },
                {
                    "valueFrom": "3.3-0",
                    "prefix": "--version",
                    "position": 0
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 36000,
                    "coresMin": 2,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/BQSR"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE| ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/globalQScorePrior"
                },
                {
                    "type": "File",
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "inputBinding": {
                        "prefix": "--input_file"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/interval_set_rule"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals over which to operate",
                    "inputBinding": {
                        "prefix": "--intervals"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "-Xmx48g -Xms256m -XX:-UseGCOverheadLimit",
                    "doc": "args to pass to java",
                    "inputBinding": {
                        "prefix": "--java_args"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/java_args"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "java.io.temp_dir, if you want to set it",
                    "inputBinding": {
                        "prefix": "--java-temp"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/java_temp"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/keep_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/logging_level"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "2",
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/num_threads"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Print the first n reads from the file, discarding the rest",
                    "inputBinding": {
                        "prefix": "--number"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/number"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Write output to this BAM filename instead of STDOUT",
                    "inputBinding": {
                        "prefix": "--out"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS| STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude all reads with this platform from the output",
                    "inputBinding": {
                        "prefix": "--platform"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/platform"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude all reads with this read group from the output",
                    "inputBinding": {
                        "prefix": "--readGroup"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/readGroup"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/refactor_NDN_cigar_string"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "File containing a list of samples (one per line). Can be specified multiple times",
                    "inputBinding": {
                        "prefix": "--sample_file"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/sample_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Sample name to be included in the analysis. Can be specified multiple times.",
                    "inputBinding": {
                        "prefix": "--sample_name"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/sample_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Simplify all reads.",
                    "inputBinding": {
                        "prefix": "--simplify"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/simplify"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/sites_only"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stderr to file",
                    "inputBinding": {
                        "prefix": "--stderr"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/stderr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "log stdout to file",
                    "inputBinding": {
                        "prefix": "--stdout"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/stdout"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/tag"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#cmo-gatk.PrintReads.cwl/out_bam"
                }
            ],
            "id": "#cmo-gatk.PrintReads.cwl",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cmo-gatk.PrintReads",
                    "http://usefulinc.com/ns/doap#revision": "3.3-0"
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_list2bed"
            ],
            "label": "cmo_list2bed",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 2000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "Convert a Picard interval list file to a UCSC BED format\n",
            "inputs": [
                {
                    "type": [
                        "string",
                        "File",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "picard interval list",
                    "inputBinding": {
                        "prefix": "--input_file"
                    },
                    "id": "#cmo-list2bed.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "doc": "sort bed file output",
                    "inputBinding": {
                        "prefix": "--no_sort"
                    },
                    "id": "#cmo-list2bed.cwl/no_sort"
                },
                {
                    "type": "string",
                    "doc": "output bed file",
                    "inputBinding": {
                        "prefix": "--output_file"
                    },
                    "id": "#cmo-list2bed.cwl/output_filename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.output_filename)\n    return inputs.output_filename;\n  return null;\n}\n"
                    },
                    "id": "#cmo-list2bed.cwl/output_file"
                }
            ],
            "id": "#cmo-list2bed.cwl",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cmo-list2bed",
                    "http://usefulinc.com/ns/doap#revision": "1.0.1"
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ]
        },
        {
            "class": "Workflow",
            "label": "module-2",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/abra_scratch"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#main/bams"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/covariates"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/dbsnp"
                },
                {
                    "type": "string",
                    "id": "#main/genome"
                },
                {
                    "type": "string",
                    "id": "#main/group"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/hapmap"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/indels_1000g"
                },
                {
                    "type": {
                        "type": "record",
                        "fields": [
                            {
                                "type": "int",
                                "name": "#main/runparams/abra_ram_min"
                            }
                        ]
                    },
                    "id": "#main/runparams"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/snps_1000g"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/list2bed/output_file",
                    "id": "#main/covint_bed"
                },
                {
                    "type": "File",
                    "outputSource": "#main/gatk_find_covered_intervals/fci_list",
                    "id": "#main/covint_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputSource": "#main/parallel_printreads/out",
                    "id": "#main/outbams"
                }
            ],
            "steps": [
                {
                    "run": "#cmo-abra.cwl",
                    "in": [
                        {
                            "source": "#main/bams",
                            "id": "#main/abra/in"
                        },
                        {
                            "valueFrom": "${ return inputs.in.map(function(x){ return x.basename.replace(\".bam\", \".abra.bam\"); }); }\n",
                            "id": "#main/abra/out"
                        },
                        {
                            "source": "#main/genome",
                            "id": "#main/abra/ref"
                        },
                        {
                            "source": "#main/runparams",
                            "id": "#main/abra/runparams"
                        },
                        {
                            "source": "#main/list2bed/output_file",
                            "id": "#main/abra/targets"
                        },
                        {
                            "source": "#main/abra_scratch",
                            "id": "#main/abra/working"
                        }
                    ],
                    "out": [
                        "#main/abra/outbams"
                    ],
                    "id": "#main/abra"
                },
                {
                    "run": "#cmo-gatk.BaseRecalibrator.cwl",
                    "in": [
                        {
                            "source": "#main/covariates",
                            "id": "#main/gatk_base_recalibrator/covariate"
                        },
                        {
                            "source": "#main/dbsnp",
                            "id": "#main/gatk_base_recalibrator/dbsnp"
                        },
                        {
                            "source": "#main/hapmap",
                            "id": "#main/gatk_base_recalibrator/hapmap"
                        },
                        {
                            "source": "#main/indels_1000g",
                            "id": "#main/gatk_base_recalibrator/indels_1000g"
                        },
                        {
                            "source": "#main/abra/outbams",
                            "id": "#main/gatk_base_recalibrator/input_file"
                        },
                        {
                            "valueFrom": "${return [inputs.dbsnp,inputs.hapmap, inputs.indels_1000g, inputs.snps_1000g]}",
                            "id": "#main/gatk_base_recalibrator/knownSites"
                        },
                        {
                            "default": "recal.matrix",
                            "id": "#main/gatk_base_recalibrator/out"
                        },
                        {
                            "valueFrom": "${ return [\"BadCigar\"]; }",
                            "id": "#main/gatk_base_recalibrator/read_filter"
                        },
                        {
                            "source": "#main/genome",
                            "id": "#main/gatk_base_recalibrator/reference_sequence"
                        },
                        {
                            "source": "#main/snps_1000g",
                            "id": "#main/gatk_base_recalibrator/snps_1000g"
                        }
                    ],
                    "out": [
                        "#main/gatk_base_recalibrator/recal_matrix"
                    ],
                    "id": "#main/gatk_base_recalibrator"
                },
                {
                    "run": "#cmo-gatk.FindCoveredIntervals.cwl",
                    "in": [
                        {
                            "valueFrom": "${ return [\"3\"];}",
                            "id": "#main/gatk_find_covered_intervals/coverage_threshold"
                        },
                        {
                            "source": "#main/group",
                            "id": "#main/gatk_find_covered_intervals/group"
                        },
                        {
                            "source": "#main/bams",
                            "id": "#main/gatk_find_covered_intervals/input_file"
                        },
                        {
                            "valueFrom": "${ return [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"X\",\"Y\",\"MT\"];}",
                            "id": "#main/gatk_find_covered_intervals/intervals"
                        },
                        {
                            "valueFrom": "${ return [\"20\"];}",
                            "id": "#main/gatk_find_covered_intervals/minBaseQuality"
                        },
                        {
                            "valueFrom": "${ return inputs.group + \".fci.list\"; }",
                            "id": "#main/gatk_find_covered_intervals/out"
                        },
                        {
                            "source": "#main/genome",
                            "id": "#main/gatk_find_covered_intervals/reference_sequence"
                        }
                    ],
                    "out": [
                        "#main/gatk_find_covered_intervals/fci_list"
                    ],
                    "id": "#main/gatk_find_covered_intervals"
                },
                {
                    "run": "#cmo-list2bed.cwl",
                    "in": [
                        {
                            "source": "#main/gatk_find_covered_intervals/fci_list",
                            "id": "#main/list2bed/input_file"
                        },
                        {
                            "valueFrom": "${ return inputs.input_file.basename.replace(\".list\", \".bed\"); }\n",
                            "id": "#main/list2bed/output_filename"
                        }
                    ],
                    "out": [
                        "#main/list2bed/output_file"
                    ],
                    "id": "#main/list2bed"
                },
                {
                    "in": [
                        {
                            "source": "#main/gatk_base_recalibrator/recal_matrix",
                            "id": "#main/parallel_printreads/BQSR"
                        },
                        {
                            "source": "#main/abra/outbams",
                            "id": "#main/parallel_printreads/input_file"
                        },
                        {
                            "source": "#main/genome",
                            "id": "#main/parallel_printreads/reference_sequence"
                        }
                    ],
                    "out": [
                        "#main/parallel_printreads/out"
                    ],
                    "scatter": [
                        "#main/parallel_printreads/input_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": {
                        "class": "Workflow",
                        "inputs": [
                            {
                                "type": "File",
                                "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/BQSR"
                            },
                            {
                                "type": "File",
                                "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/input_file"
                            },
                            {
                                "type": "string",
                                "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/reference_sequence"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "secondaryFiles": [
                                    "^.bai"
                                ],
                                "outputSource": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/out_bam",
                                "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/out"
                            }
                        ],
                        "steps": [
                            {
                                "run": "#cmo-gatk.PrintReads.cwl",
                                "in": [
                                    {
                                        "source": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/BQSR",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/BQSR"
                                    },
                                    {
                                        "valueFrom": "${ return ['RECALCULATE'];}",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/baq"
                                    },
                                    {
                                        "valueFrom": "${ return true; }",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/emit_original_quals"
                                    },
                                    {
                                        "source": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/input_file",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/input_file"
                                    },
                                    {
                                        "default": "5",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/num_cpu_threads_per_data_thread"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.input_file.basename.replace(\".bam\", \".printreads.bam\"); }\n",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/out"
                                    },
                                    {
                                        "source": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/reference_sequence",
                                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/reference_sequence"
                                    }
                                ],
                                "out": [
                                    "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads/out_bam"
                                ],
                                "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557/gatk_print_reads"
                            }
                        ],
                        "id": "#main/parallel_printreads/c3dd25b5-7efe-4773-baa8-d6620e503557"
                    },
                    "id": "#main/parallel_printreads"
                }
            ],
            "id": "#main",
            "http://usefulinc.com/ns/doap#release": [
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "module-2",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                },
                {
                    "class": "http://usefulinc.com/ns/doap#Version",
                    "http://usefulinc.com/ns/doap#name": "cwl-wrapper",
                    "http://usefulinc.com/ns/doap#revision": "1.0.0"
                }
            ],
            "http://purl.org/dc/terms/creator": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ],
            "http://purl.org/dc/terms/contributor": [
                {
                    "class": "http://xmlns.com/foaf/0.1/Organization",
                    "http://xmlns.com/foaf/0.1/name": "Memorial Sloan Kettering Cancer Center",
                    "http://xmlns.com/foaf/0.1/member": [
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Christopher Harris",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:harrisc2@mskcc.org"
                        },
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Ronak H. Shah",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:shahr2@mskcc.org"
                        },
                        {
                            "class": "http://xmlns.com/foaf/0.1/Person",
                            "http://xmlns.com/foaf/0.1/name": "Jaeyoung Chun",
                            "http://xmlns.com/foaf/0.1/mbox": "mailto:chunj@mskcc.org"
                        }
                    ]
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "http://dublincore.org/2012/06/14/dcterms.rdf",
        "http://usefulinc.com/ns/doap#",
        "http://xmlns.com/foaf/spec/20140114.rdf"
    ],
    "$namespaces": {
        "dct": "http://purl.org/dc/terms/",
        "foaf": "http://xmlns.com/foaf/0.1/",
        "doap": "http://usefulinc.com/ns/doap#"
    }
}
